<template>
  <ob-form
    ref="form"
    class="tenders-add-field-form"
    :form-data="formData"
    :form-model="formModel"
    :is-submit-disabled="isSubmitDisabled"
    :is-loading="isPending"
    ok-text="Создать"
    cancel-text="Отменить"
    data-qa="tendersGroupsAddForm"
    @submit="onSubmit"
  >
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          :key="inputKey"
          label="Имя группы"
          v-model="formData.title"
          property="title"
          :required="true"
          :is-dirty-force="isDirtyForce"
          placeholder="Например, Минимальные затраты"
          data-qa="title"
        />
      </div>
    </div>

    <div class="row">
      <div class="col-xs-12">
        <ob-textarea
          label="Описание (необязательно)"
          v-model="formData.description"
          placeholder="Например, особенности контрагентов, добавляемых в эту группу или условия попадания в нее"
          data-qa="description"
        />
      </div>
    </div>
  </ob-form>
</template>

<script>
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
  import ObForm              from 'common-components/src/obComponents/obForm'
  import ObInput             from 'common-components/src/obComponents/obInput'
  import ObTextarea          from 'common-components/src/obComponents/obTextarea'
  import { required }        from 'vuelidate/lib/validators'
  import api                 from '@/api'

  export default {
    name: 'TendersCreateParticipantGroup',
    mixins: [
      FormValidationMixin
    ],
    components: {
      ObInput,
      ObForm,
      ObTextarea
    },
    props: {
      title: {
        type: String,
        default: ''
      },
      isDirtyForce: {
        type: Boolean,
        default: false
      }
    },
    data () {
      return {
        isPending: false,
        isSubmitDisabled: true,
        checkExistsTimeout: null,
        inputKey: 0
      }
    },
    computed: {
      formModel () {
        return {
          uuid: {
            value: null
          },
          title: {
            value: this.title,
            validator: {
              required,
              isUnique: {
                method: this.checkTitle,
                error: 'Группа с таким названием уже есть. Измените имя или придумайте новое'
              }
            }
          }
        }
      }
    },
    watch: {
      '$parent.visible' (isVisible) {
        if (isVisible) {
          this.inputKey++

          if (this.isDirtyForce) {
            this.isPending = true
          }
        }
      }
    },
    mounted () {
      if (this.isDirtyForce) {
        this.isPending = true
      }

      // By default form is watching for 'isValid' and 'formIsChanged',
      // but in current component form can be ready to submit, but not changed
      this.$watch('$refs.form.isValid', (isFormValid) => {
        this.isSubmitDisabled = !isFormValid
      })
    },
    methods: {
      async checkTitle (title) {
        if (title === '') {
          return true
        }

        clearTimeout(this.checkExistsTimeout)

        return new Promise((resolve) => {
          this.checkExistsTimeout = setTimeout(async () => {
            this.isPending = true

            const response = await api.tendersContractors.checkParticipantGroupExisting({ title })

            resolve(!response.error)

            this.isPending = false
          }, 700)
        })
      },
      async onSubmit (data) {
        let uuid

        try {
          const response = await api.tendersContractors.createParticipantGroup({
            title: data.title,
            description: data.description
          })

          uuid = response.data.uuid

          if (response.status === 201) {
            this.$notification({
              type: 'system_notification_success',
              message: `Группа «${data.title}» успешно создана`
            })
          } else if (response.status === 409) {
            this.$notification({
              type: 'system_notification_error',
              message: `Группа «${data.title}» уже существует`
            })
          }
        }
        catch (e) {
          console.error(e);

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка при создании группы'
          })
        }

        this.$emit('submit', uuid)
      }
    }
  }
</script>
